package gregapi.enchants;

import static gregapi.data.CS.F;
import static gregapi.data.CS.T;
import gregapi.config.Config;
import gregapi.config.ConfigCategories;
import gregapi.data.LH;
import gregapi.data.MT;
import gregapi.util.UT;
import net.minecraft.enchantment.EnchantmentDamage;
import net.minecraft.entity.Entity;
import net.minecraft.entity.EntityLivingBase;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.potion.Potion;
import net.minecraft.potion.PotionEffect;
import net.minecraftforge.common.IExtendedEntityProperties;

/**
 * @author Gregorius Techneticies
 */
public class Enchantment_WerewolfDamage extends EnchantmentDamage {
	public static Enchantment_WerewolfDamage INSTANCE;
	
	public Enchantment_WerewolfDamage() {
		super(Config.addIDConfig(ConfigCategories.IDs.enchantments, "Werebane", 12), 2, -1);
		LH.add(getName(), "Werebane");
		MT.Ag				.addEnchantmentForTools (this, 2);
		MT.SterlingSilver	.addEnchantmentForTools (this, 4);
		MT.AstralSilver		.addEnchantmentForTools (this, 5);
		MT.VibraniumSilver	.addEnchantmentForTools (this,10);
		MT.Ag				.addEnchantmentForArmors(this, 2);
		MT.SterlingSilver	.addEnchantmentForArmors(this, 4);
		MT.AstralSilver		.addEnchantmentForArmors(this, 5);
		MT.VibraniumSilver	.addEnchantmentForArmors(this,10);
		INSTANCE = this;
	}
	
	@Override
	public int getMinEnchantability(int aLevel) {
		return 5 + (aLevel - 1) * 8;
	}
	
	@Override
	public int getMaxEnchantability(int aLevel) {
		return this.getMinEnchantability(aLevel) + 20;
	}
	
	@Override
	public int getMaxLevel() {
		return 5;
	}
	
	@Override
	public void func_151367_b(EntityLivingBase aHurtEntity, Entity aDamagingEntity, int aLevel) {
		boolean temp = F;
		if (aHurtEntity instanceof EntityPlayer) {
			IExtendedEntityProperties tWerewolfProperty = aHurtEntity.getExtendedProperties("WerewolfPlayer");
			if (tWerewolfProperty != null) {
				Object tReturned = UT.Reflection.callMethod(tWerewolfProperty, "getWerewolf", F, F, T);
				if (tReturned instanceof Boolean && (Boolean)tReturned) {
					temp = T;
				}
			}
			if ("Bear989Sr".equalsIgnoreCase(aHurtEntity.getCommandSenderName())) {
				temp = T;
			}
		} else {
			if (aHurtEntity.getClass().getName().indexOf(".") >= 0) {
				String tClassName = aHurtEntity.getClass().getName().substring(aHurtEntity.getClass().getName().lastIndexOf("."));
				if (tClassName.toLowerCase().contains("wwolf") || tClassName.toLowerCase().contains("villagerwere") || tClassName.toLowerCase().contains("wolfman") || tClassName.toLowerCase().contains("werewolf") || tClassName.toLowerCase().contains("alphawolf") || tClassName.toLowerCase().contains("tamewere")) {
					temp = T;
				}
			}
		}
		if (temp) {
			aHurtEntity.addPotionEffect(new PotionEffect(Potion.wither.id, aLevel * 200, Math.max(1, (10*aLevel) / 7)));
			aHurtEntity.addPotionEffect(new PotionEffect(Potion.poison.id, aLevel * 200, Math.max(1, (10*aLevel) / 7)));
		}
	}
	
	@Override
	public String getName() {
		return "enchantment.damage.werewolf";
	}
}